#include <iostream>
#include <gtkmm.h>

#include <iostream>
#include <cstring>

class ImgDiff: public Gtk::Window{

  Gtk::Image  img1,img2;
  Gtk::Label  l1,l2;
  Gtk::VBox   vbox;
  Gtk::HBox   hbox1, hbox2;
  Gtk::Button butt;
  Glib::RefPtr<Gdk::Pixbuf> I1,I2;
  bool once;

public:
  ImgDiff(bool _once): butt(_once? Gtk::Stock::OK:Gtk::Stock::GO_FORWARD), once(_once){
    set_default_size(640,480);
    hbox1.pack_start(img2, true, true);
    hbox1.pack_start(img1, true, true);
    hbox2.pack_start(l2, true, true);
    hbox2.pack_start(l1, true, true);
    vbox.pack_start(hbox1, true, true);
    vbox.pack_start(hbox2, true, true);
    vbox.pack_start(butt, false, true);
    butt.signal_clicked().connect(sigc::mem_fun(*this, &ImgDiff::go_next));
    signal_expose_event().connect( sigc::mem_fun(*this, &ImgDiff::on_redraw));
    signal_delete_event().connect(sigc::mem_fun(*this, &ImgDiff::on_delete));
    add (vbox);
  }

  gboolean load_pics(const char * a, const char *b){
      l1.set_label(a);
      l2.set_label(b);
    try{
      I1 = Gdk::Pixbuf::create_from_file(a);
    }catch(Glib::FileError e){I1.clear();}
    try{
      I2 = Gdk::Pixbuf::create_from_file(b);
    }catch(Glib::FileError e){I2.clear();}
    return true;
  }

  void go_next(){ 
    if (once) {hide(); return;}
    std::string s1, s2;
    std::cin >> s1 >> s2;
    if (std::cin.eof()) {hide(); return;}
    load_pics(s1.c_str(), s2.c_str());
  };

  gboolean on_redraw (GdkEventExpose * e){
    int w1 = I1? I1->get_width():256;
    int w2 = I2? I2->get_width():256;
    int h1 = I1? I1->get_height():256;
    int h2 = I2? I2->get_height():256;

    int w =get_width();
//    int h =get_height(); 

    if (I1) img1.set(I1->scale_simple((w1*w)/(w1+w2),(h1*w)/(w1+w2),Gdk::INTERP_TILES)); 
    else img1.set_from_icon_name("", Gtk::ICON_SIZE_LARGE_TOOLBAR);
    if (I2) img2.set(I2->scale_simple((w2*w)/(w1+w2),(h2*w)/(w1+w2),Gdk::INTERP_TILES)); 
    else img2.set_from_icon_name("", Gtk::ICON_SIZE_LARGE_TOOLBAR);
    return TRUE;
  }

  gboolean on_delete (GdkEventAny * e){
    hide();
    return TRUE;
  }
  
};


void usage(const char * name){
    std::cout << "usage: " << name << " <image1> <image2>\n"
              << "       echo \"<img1> <img2>  <img3> <img4>  ...\" | " 
              << name << "\n";
  exit(1);
}

int main (int argc, char **argv){

  if (argc < 2) usage(argv[0]);

  Gtk::Main app (argc, argv);
  ImgDiff win(argc>2);

  if (argc>2){
    win.load_pics(argv[1], argv[2]);
  } else if ((argc > 1) && (strcmp(argv[1], "--stdin")==0 )){
    win.go_next();
  } else  usage(argv[0]);

  win.show_all();
  app.run(win);

  return 0;
}
